const Discord = require("discord.js");
const {DB} = require('mongquick');
const delay = (ms) => new Promise((resolve) => setTimeout(resolve, ms));
var settings, type, mid, bot, r, log;
async function start(client, url, logs){
  if (url == 'local') {
    type = "quick";
const Database = require("easy-json-database");
settings = new Database("./tickets.json", {
    snapshots: {
        enabled: true,
        interval: 24 * 60 * 60 * 1000,
        folder: './backups/'
    }
});
  } else {
    type = 'mongo';
    settings = new DB(url);
  }
  if (logs == true) {
    log = true
  }
if(!client) throw new Error("Client not provided, Ticket system will not be working.")
bot = client;
client.on("interactionCreate", async (interaction) => {
  if (!(interaction.isButton())) return;
  if (!(interaction.customId == 'cr')) return;
  if (interaction.member.user.bot) return;
  const reaction = interaction;
  await interaction.deferReply({ephemeral: true});
  if (type == 'mongo') {
  if (!(await(settings.has(`${interaction.guild.id}-ticket`)))) return;
  if (reaction.channel.id == (await(settings.get(`${interaction.message.guild.id}-ticket`)))) {
    if (log == true) {
      ticket(interaction, (await(settings.get(`r${interaction.guild.id}`))), (await(settings.get(`${interaction.guild.id}-parent`) || null)));
      return  
    }
    ticket(interaction, (await(settings.get(`r${interaction.guild.id}`))), (await(settings.get(`${interaction.guild.id}-parent`) || null)));
  }
} else {
  if (!((settings.has(`${interaction.guild.id}-ticket`)))) return;
  if (reaction.channel.id == ((settings.get(`${interaction.message.guild.id}-ticket`)))) {
    if (log == true) {
      ticket(interaction, settings.get(`r${interaction.guild.id}`), (settings.get(`${interaction.guild.id}-parent`) || null));
      return
    }
    ticket(interaction, settings.get(`r${interaction.guild.id}`), (settings.get(`${interaction.guild.id}-parent`) || null));
  }
}
});
}
async function ticket(interaction, rname, parent) {
  if(!bot) throw new Error("Client not provided, Ticket system will not be working.")
  let reaction = interaction;
  reaction.guild.channels
  .create(`ticket-${interaction.member.user.username}`, {
    permissionOverwrites: [
      {
        id: interaction.member.user.id,
        allow: ["SEND_MESSAGES", "VIEW_CHANNEL"]
      },
      {
        id: reaction.guild.id,
        deny: ["VIEW_CHANNEL"]
      },
      {
        id: reaction.guild.roles.cache.find(
          role => role.id === rname
        ),
        allow: ["SEND_MESSAGES", "VIEW_CHANNEL"]
      }
    ],
    type: "text"
  })
  .then(async channel => {
    if (log == true) {
      emit("ticketCreate", reaction, `Ticket für ${channel.name.replace("ticket-", "")} wurde erstellt.`, "GREEN")
    }
    if (parent) {
      channel.setParent(parent)
    }
    settings.set(channel.id, interaction.member.user.id);
    channel.send({
      content: String(`<@${interaction.member.user.id}>\n<@&${rname}>`),
      embeds: [new Discord.MessageEmbed()
        .setTitle("Willkommen im Ticket!")
        .setDescription("Ein Teamler sollte sich bald melden")
        .setColor("#ffcc00")
        .setFooter("GrieferCoin", "https://cdn.discordapp.com/icons/812850974443307058/315c3845d1d11a7d41bd3a4325b7abea.webp?size=256")],
      components: [
        new Discord.MessageActionRow().addComponents(
          new Discord.MessageButton()
          .setStyle('DANGER')
          .setLabel("Ticket schließen")
          .setCustomId('cl')
          .setEmoji('🔒')
        )
      ]
    }).then(m => {
      let collector = m.createMessageComponentCollector({
        max: 3
    });
    collector.on('collect', async i => {
      if (i.user.id !== interaction.member.user.id) {
        await i.reply({
          content: String("Du kannst dies nicht tun"), 
          ephemeral: true
        })
        return
      }
      await i.update({
        embeds: [new Discord.MessageEmbed()
          .setTitle("Willkommen im Ticket!")
          .setDescription("Das Ticket wurde archiviert")
          .setColor("#ffcc00")
          .setFooter("GrieferCoin", "https://cdn.discordapp.com/icons/812850974443307058/315c3845d1d11a7d41bd3a4325b7abea.webp?size=256")],
        components: [
          new Discord.MessageActionRow().addComponents(
            new Discord.MessageButton()
            .setStyle('DANGER')
            .setLabel("Ticket geschlossen")
            .setCustomId('cl')
            .setEmoji('🔏')
            .setDisabled(true)
          )
        ]
      })
      archive(channel)
    })
    });
  });
}
async function setup(message,channelID, parentid){
  if(!bot) throw new Error("Client not provided, Ticket system will not be working.")
    const channel = message.guild.channels.cache.find(channel => channel.id === channelID);
    let s4dmessage = message;
    message.channel.send({
        embeds: [
          new Discord.MessageEmbed()
            .setTitle("Ticket System")
            .setDescription("Wähle deine Einstellungen")
            .setFooter(`Ticket für ${message.guild.name}`)
            .setColor("#ffcc00")
            .setFooter("GrieferCoin", "https://cdn.discordapp.com/icons/812850974443307058/315c3845d1d11a7d41bd3a4325b7abea.webp?size=256")
        ],
        components: [
              new Discord.MessageActionRow().addComponents(
                new Discord.MessageButton()
                .setStyle('PRIMARY')
                .setLabel("Standart Einstellungen")
                .setCustomId('pri')
                .setEmoji('🥇'),
                new Discord.MessageButton()
                .setStyle('SECONDARY')
                .setLabel("Custom Einstellungen")
                .setCustomId('sec')
                .setEmoji('🥈')
              )
            ]
      }).then(sent => {
        let collector = sent.createMessageComponentCollector({
            max: 3
        });
        collector.on('collect', async i => {
        if (i.user.id !== (message.member).id) {
            await i.reply({
              content: String("Du kannst dies nicht tun!"), 
              ephemeral: true
            })
            return
        }
        if (i.customId == 'pri') {
            await i.reply({
                content: String("Fertig!"), 
                ephemeral: true
            });
            if (log == true) {
            issue(message, channel, 'Klicke um ein Ticket zu eröffnen', "Ticket", parentid);
            } else {
              issue(message, channel, 'Klicke um ein Ticket zu eröffnen', "Ticket", parentid);
            }
        }
        if (i.customId == 'sec') {
            await i.reply({
                content: String("Fertig"), 
                ephemeral: true
            });
            (s4dmessage.channel).send(String('Ticket message (Description)')).then(() => {
                (s4dmessage.channel).awaitMessages({
                    filter: (m) => m.author.id === (s4dmessage.member).id,
                    time: (1 * 60 * 1000),
                    max: 1
                }).then(async (collected) => {
                    reply = collected.first().content;
                    mess = reply;
                    message = collected.first();
                    (s4dmessage.channel).send(String('CUstom role:')).then(() => {
                        (s4dmessage.channel).awaitMessages({
                            filter: (m) => m.author.id === (s4dmessage.member).id,
                            time: (1 * 60 * 1000),
                            max: 1
                        }).then(async (collected) => {
                            reply = collected.first().content;
                            rolen = reply;
                            message = collected.first();
                            if (log == true) {
                            issue(message, channel, mess, rolen, parentid);  
                            } else {
                            issue(message, channel, mess, rolen, parentid);
                            }
                            reply = null;
                        }).catch(async (e) => {
                            console.error(e);
                            s4dmessage.channel.send({
                                content: String('Discarded!')
                            });
                        });
                    })
    
                    reply = null;
                }).catch(async (e) => {
                    console.error(e);
                    s4dmessage.channel.send({
                        content: String('Discarded!')
                    });
                });
            })
        }
        collector.stop()
    });
      });
    }
async function issue(message, channel, msg, rolename, parent){
    channel.send({
        embeds: [
          new Discord.MessageEmbed()
            .setTitle("Ticket System")
            .setDescription(String(msg))
            .setFooter(`Ticket für ${message.guild.name}`)
            .setColor("#ffcc00")
            .setFooter("GrieferCoin", "https://cdn.discordapp.com/icons/812850974443307058/315c3845d1d11a7d41bd3a4325b7abea.webp?size=256")

        ],
        components: [
              new Discord.MessageActionRow().addComponents(
                new Discord.MessageButton()
                .setStyle('SUCCESS')
                .setLabel("Ticket öffnen")
                .setCustomId('cr')
                .setEmoji('🎫')
              )
            ]
      }).then(() => {
        settings.set(`${message.guild.id}-ticket`, channel.id);
        if (parent) {
          settings.set(`${message.guild.id}-parent`, String(parent));
        }
      });
      if (!(message.guild.roles.cache.find(role => role.name == rolename))) {

        message.guild.roles.create({
            name: String(rolename),
            color: "#ffcc00"
        }).then(role => {
            role.setPermissions([Discord.Permissions.FLAGS.VIEW_CHANNEL, Discord.Permissions.FLAGS.SEND_MESSAGES]);
            role.setMentionable(false);
            settings.set(`r${message.guild.id}`, role.id);
            message.channel.send(`Rolle \`${rolename}\` und Ticket System erfolgreich erstellt`);
        });
            } else {
              message.channel.send(`Rolle \`${rolename}\` und Ticket System erfolgreich erstellt`);
              settings.set(`r${message.guild.id}`, ((message.guild.roles.cache.find(role => role.name == rolename)).id));
            }
}
async function unarchive(channel){
  if(!bot) throw new Error("Client not provided, Ticket system will not be working.")
  if (type == 'mongo') {
    if (!(await(settings.has(channel.id)))) {
      channel.send({
        content: String("User nicht gefunden")
      })
      return
    }
    if (log == true) {
      edit(channel, (await(settings.get(`r${channel.guild.id}`))), (await(settings.get(channel.id))));
      return
      }
    edit(channel, (await(settings.get(`r${channel.guild.id}`))), (await(settings.get(channel.id))));
  } else {
    if (!((settings.has(channel.id)))) {
      channel.send({
        content: String("User nicht gefunden")
      })
      return
    }
    if (log == true) {
    edit(channel, (settings.get(`r${channel.guild.id}`)), (settings.get(channel.id)));
    return
    }
    edit(channel, (settings.get(`r${channel.guild.id}`)), (settings.get(channel.id)));
  }
}
async function edit(channel, rname, mid, logname) {
  channel.edit({
    permissionOverwrites: [
    {
      id: mid,
      allow: ["VIEW_CHANNEL", "SEND_MESSAGES"]
    },
    {
      id: channel.guild.id,
      deny: ["VIEW_CHANNEL"]
    },
    {
      id: channel.guild.roles.cache.find(
        role => role.id === rname
      ),
      allow: ["SEND_MESSAGES", "VIEW_CHANNEL"]
    }
  ]
  });
  if (log == true) {
    emit("ticketUnarchive", channel, `Ticket for ${channel.guild.members.cache.find(m => m.user.id == mid).user.username} was **unarchived**`, "YELLOW")
  }
  channel.send({
    content: `Hallo <@${mid}>\nDein Ticket wurde wiedergeöffnet`,
    components: [new Discord.MessageActionRow()
    .addComponents(
      new Discord.MessageButton()
      .setStyle("DANGER")
      .setLabel("Schließen")
      .setEmoji("🔒")
      .setCustomId('lk')
    )]
  }).then(async f => {
    let collector = f.createMessageComponentCollector({
      max: 3
    });
    collector.on('collect', async i => {
      await i.reply({
        content: String(`Ok <@${i.user.id}>`)
      })
      archive(channel);
      collector.stop();
    });
    collector.on('end', async i => {
      f.edit({
        content: `Hallo <@${mid}>\nDein Ticket wurde wiedergeöffnet`,
    components: [new Discord.MessageActionRow()
    .addComponents(
      new Discord.MessageButton()
      .setStyle("DANGER")
      .setLabel("Schließen")
      .setEmoji("🔒")
      .setCustomId('lk')
      .setDisabled(true)
    )]
      });
    })
  });
}
async function archive(message){
  if(!bot) throw new Error("Client not provided, Ticket system will not be working.")
  if (!message.name.includes("ticket-")){
    message.send("Du kannst dies hier nicht benutzen");
    return 
    }
    if (type == 'mongo') {
      if (log == true) {
      ar(message, (await(settings.get(`r${message.guild.id}`))));
      return
      }
      ar(message, (await(settings.get(`r${message.guild.id}`))));
    } else {
      if(log == true) {
      ar(message, (settings.get(`r${message.guild.id}`)));
      return
      }
      ar(message, (settings.get(`r${message.guild.id}`)));
    }
}
async function ar(message, rname){
  let channel = message;
  message.edit({
    permissionOverwrites: [
    {
      id: message.guild.id,
      deny: ["VIEW_CHANNEL"]
    },
    {
      id: message.guild.roles.cache.find(
        role => role.id === rname
      ),
      allow: ["SEND_MESSAGES", "VIEW_CHANNEL"]
    }
  ]
});
if (log == true) {
  emit("ticketArchive", channel, `Ticket von ${channel.name.replace("ticket-", "")} wurde archiviert!`, "YELLOW")
}
}
async function close(message){
  if(!bot) throw new Error("Client not provided, Ticket system will not be working.")
  if (!message.name.includes("ticket-")){
  message.send("You cannot use that here!");
  return 
  }
  settings.delete(message.id);
message.delete();
if (log == true) {
  emit("ticketClose", message, `Ticket für ${message.name.replace("ticket-", "")} wurde geschlossen!`, "RED")
}
}
async function version() {
  return "version 4";
}
async function emit(a, b, c, d){
  const reaction = b;
  if (!(b.guild.channels.cache.find(c => c.name == "ticket-logs"))) {
    b.guild.channels.create("ticket-logs", {
      permissionOverwrites: [
        {
          id: reaction.guild.id,
          deny: ["VIEW_CHANNEL"]
        }
      ],
      type: "text"
    });
  }
  b.guild.channels.cache.find(c => c.name == "ticket-logs").send({
    embeds: [new Discord.MessageEmbed()
    .setTitle(String(a))
    .setDescription(String(c))
    .setColor(d)
    ]
  });

}
module.exports = {
  setup: setup,
  start: start,
  close: close,
  archive: archive,
  unarchive: unarchive,
  setup,
  start,
  close,
  archive,
  unarchive,
  version,
  emit
}